# import
from PIL import Image, ImageDraw

# constants
N = 16000000
M = 4000
OFFSET = 2

# prepare
image = Image.new("1", (M + 2 * OFFSET, int(N/M) + 2 * OFFSET), 1)
draw = ImageDraw.Draw(image)
removed = [False for i in range(0, N)]


# calculate and draw
for i in range(2, N):
    if not removed[i]:
        x = int(i % M)
        y = int(i / M)
        draw.ellipse((x-OFFSET, y-OFFSET, x+OFFSET, y+OFFSET), fill=0)
        
        for j in range(i*i, N, i):
            removed[j] = True
            
    if i % (N / 50) == 0:
        print('.', end='')

# save image
image.save("out.png")
